<?php
namespace Fiscal\Logic\ImportaTipoItem;


/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of TipoItemSped
 *
 * @author carinaoliveira
 */
use Geral\Entities\TipoItemProd;
use Fiscal\Entities\Tipoitemsped as tpitemsped;
use Geral\Util\DateUtil;
use Geral\Util\Ambiente;
use Indeterminado\Entities\RelacProdItGen;
use Setforms2\Shared\Registry;

class TipoItemSped {
    
    public static function replicaItemProd($nrorg, $cdLivroDest){
        
        /*Valida se existe algum cadastro de Produto por Tp. Item/Gênero pois assim os tipos de itens atuais não podem ser substituídos.*/
        $proditgen = RelacProdItGen::findByNrorgAndCdlivromag($nrorg, $cdLivroDest);
        if ($proditgen == null) {
            $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $connection->beginTransaction();

            try{
                self::replicaRegistrosItem($nrorg, $cdLivroDest);
                $connection->commit();
            } catch (\Exception $e){
                $connection->rollback();
                throw $e;
            }  

        } else {
            throw new \Exception ("Operação Bloqueada! Os cadastros não podem ser substituídos pois estão sendo usados na aba Produto por Tipo de Item/Gênero.");
                        
        }
    }

    
    public static function replicaRegistrosItem($nrorg, $cdLivroDest) {
        
        /*A função replica os tipos de item entre um livro e a tabela padrao de sped conforme os parâmetros informados, de forma que,
          são excluídos todos os tipos de item do livro de destino e então são inseridos todos os itens do livro
          da tabela padrao de sped para o livro de destino.*/

        $dataAtual = DateUtil::getDataAtual();
        $cdoperador = Ambiente::getCdOperador();

        try {

            /*São apagados os cadastros de Tipo de Item do livro de destino para serem incluídos os novos.*/
            $repositorioTipoItemProd = TipoItemProd::getRepository();
            $repositorioTipoItemProd->deleteByCdlivromagAndNrorg($cdLivroDest, $nrorg);
            Registry::getEntityManager()->flush();

            /*São buscados todos os tipos de item da tabela padrao de sped e para cada um são criados novos itens com o código do livro de destino.*/
            $itens = tpitemsped::getObjectsByWhere('1=1');

            foreach ($itens as $item) {
                $newitemprod = new TipoItemProd();
                $newitemprod->setCdlivromag($cdLivroDest);
                $newitemprod->setCdtpitemprod($item->getCdtipoitem());
                $newitemprod->setNmtpitemprod($item->getDstipoitem());
                $newitemprod->setNrorginclusao($nrorg);
                $newitemprod->setCdoperultatu($cdoperador);
                $newitemprod->setNrorg($nrorg);
                $newitemprod->setDtinclusao($dataAtual);
                $newitemprod->setDtultatu($dataAtual);
                $newitemprod->setNrorgultatu($nrorg);
                $newitemprod->setCdoperinclusao($cdoperador);

                /*Um a um os itens são persistidos. O flush é executado na função de origem 'replicaItemProd'*/
                $newitemprod->persist();
            }

            Registry::getEntityManager()->flush();

        } catch (\Exception $e) {          
            throw $e;
        }

    }
}

?>
