/* Sistemas Integrados TECNISA

BEGIN_CONV
Nome: 0000_PEDTMP_FILIAL.SQL

Descrio:
Script para preencher o campo de filial nas tabelas PARAMPEDIDO e PAREXPEDICAO

Criao:
10/02/2004 Raphael Freitas Pinheiro
*/

ALTER TABLE PARAMPEDIDO  ADD CDFILIAL VARCHAR(4);
GO
ALTER TABLE PAREXPEDICAO ADD CDFILIAL VARCHAR(4);
GO

DECLARE @V_CDFILIPROC VARCHAR(4);
DECLARE @V_CTPARAMPED NUMERIC;
DECLARE @V_CTPARAMEXP NUMERIC;
DECLARE @V_PARAMGERAL NUMERIC;

BEGIN
   SELECT @V_PARAMGERAL = COUNT(*)
   FROM PARAMGERAL;

   IF (@V_PARAMGERAL > 0) BEGIN
      SELECT @V_CDFILIPROC = CDFILIAL
      FROM PARAMGERAL;

      SELECT @V_CTPARAMPED = COUNT(*)
      FROM PARAMPEDIDO
      WHERE CDFILIAL IS NULL;

      IF @V_CTPARAMPED > 0 BEGIN
         UPDATE PARAMPEDIDO
         SET CDFILIAL = @V_CDFILIPROC
         WHERE CDFILIAL IS NULL;
      END;

      SELECT @V_CTPARAMEXP = COUNT(*)
      FROM PAREXPEDICAO
      WHERE CDFILIAL IS NULL;

      IF @V_CTPARAMEXP > 0 BEGIN
         UPDATE PAREXPEDICAO
         SET CDFILIAL = @V_CDFILIPROC
         WHERE CDFILIAL IS NULL;
      END;
   END;
END;
GO

ALTER TABLE PARAMPEDIDO  ALTER COLUMN CDFILIAL VARCHAR(4) NOT NULL;
GO
ALTER TABLE PAREXPEDICAO ALTER COLUMN CDFILIAL VARCHAR(4) NOT NULL;
GO