/*  Para essa tela, utilizei:
    cmp06500_log_de_autorizacao_de_fornecimento_Controller.js
    cmp06500_log_de_autorizacao_de_fornecimento.json
    Cmp06500LogDeAutorizacaoDeFornecimento.php
    routes.json de solicitacao/modules/relatorios/config
    controllers.xml (mesma pasta do routes.json)
*/

function cmp06500_log_de_autorizacao_de_fornecimento_Controller(ScreenService, General, Sup03000Service, localStorageEngine, Parametros, Sup03600PedidoColetaService, MessageService) {

    //cria variável para usar quando fizer referência a uma função do próprio js.
    var self = this;

    //função para permitir apenas inserção de números no campo
    this.onlyNumbers = function(field) {
    //se o caracter que acabou de ser digitado for "not a number", ele é instantaneamente apagado
		if(isNaN(parseInt(field.value().charAt(field.value().length - 1)))) {
			field.value(field.value().toString().slice(0, -1));
		}
	};
    
    //função chamada ao clicar em OK na tela
    this.criaRelatorio = function(widget) {
        //a variável reportName recebe o relatório que deverá ser gerado.
        var row = angular.copy(widget.currentRow);
        //widget.isValid diz respeito a todos os campos obrigatórios estarem preenchidos
        //se isso e as datas estiverem válidas, chama o controller do php
        if (widget.isValid()) {
            if(this.validaProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN)) {
            
            var reportName  = widget.currentRow.REPORT_NAME;
            
            if (!Util.isEmptyObject(row.FILIALDEST)) {
                row.FILIALDEST = row.FILIALDEST.join("_");
            } else {
                row.FILIALDEST = "T";
            }
            
            if (!Util.isEmptyObject(row.OPERADOR)) {
                row.OPERADOR = row.OPERADOR.join("_");
            } else {
                row.OPERADOR = "T";
            }
            
            if (widget.currentRow.NRAUTFOR === "") {
                row.NRAUTFOR = "T";
            }
            
            General.openReportPopup(widget, self.abreRelatorio, [widget, row, reportName]);  
            }
        }
    };
    this.preencheCaracterDireta = function(string){
        var pad = 'ZZZZZZZZZZ';
        return string + pad.substr(0, pad.length - string.length);    
    };
    
   
    this.changeRequired = function(field){
        if (field.widget.getField('NMPRODINI').value() || field.widget.getField('NMPRODFIN').value()){
            field.widget.getField('NMPRODINI').validations = { "required" : true };
            field.widget.getField('NMPRODFIN').validations = { "required" : true };
        } else {
            field.widget.getField('NMPRODINI').validations = {};
            field.widget.getField('NMPRODFIN').validations = {};
        }
    };

    this.validaProduto = function(prodInicial, prodFinal) {

        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }

        return true;
    }; 
    
    this.abreRelatorio = function(widget, currentRow, reportName) {          
        if(!currentRow.CDPRODFIN) {
            currentRow.CDPRODINI = null;
            currentRow.CDPRODFIN = null;
            currentRow.TCDPRODUTO = 'T';
        }
        else {
            currentRow.CDPRODFIN = self.preencheCaracterDireta(currentRow.CDPRODFIN);
            currentRow.TCDPRODUTO = null;
        }
        currentRow.DTINI   = currentRow.INTERVAL_DT.start;
        currentRow.DTFIM   = currentRow.INTERVAL_DT.end;
        currentRow.DATAINIC   = currentRow.INTERVAL_DT.start;
        currentRow.DATAFINA   = currentRow.INTERVAL_DT.end;
   	    General.openReport('cmp_fornecimento_autorizacaoFornecimento#/cmp_fornecimento_autorizacaoFornecimento/cmp06500_relatorio', reportName, currentRow); 
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp06500_log_de_autorizacao_de_fornecimento_Controller', cmp06500_log_de_autorizacao_de_fornecimento_Controller);
});