function Cmp04100BaixaAFsController(ScreenService, General, Utilities, templateManager, MessageService) {
	
	function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
	
	function concatenaEscolhas(currentRow) {

		let escolhas = '';
		let array = currentRow.ESCOLHAS;
		
		currentRow.P_IDBAIXAAF_NULL = "Z";
    
        for(let i = 0; i<array.length; i++){
            
            switch (array[i]) {
        	    case '0':
        	        escolhas += '1';
        	        break;
        	    case '1':
        	        escolhas += '_2';
        	        break;
        	    case '2':
        	        escolhas += '_3';
        	        break;
        	    case '3': 
        	        escolhas += '_4';
        	        break;
        	    case '4':
        	        escolhas += '_5';
        	        break;
        	    case '5':
        	        currentRow.P_IDBAIXAAF_NULL = "X";
        	        break;
        	}
        }	
		
		if (escolhas === '') escolhas = '0';
    	if (escolhas !== '') currentRow.P_IDBAIXAAF = escolhas;

		currentRow.CDPRODFIM = currentRow.CDPRODFINAL;
		currentRow.CDPRODINI = currentRow.CDPRODUTO;
		currentRow.DATAINI 	 = currentRow.INTERVALO_DATA.start;
		currentRow.DATAFIN 	 = currentRow.INTERVALO_DATA.end;
		currentRow.NRORG 	 = getLocalVar('NRORG');
	}

    this.productValidations = function(field) {
        const row         = field.widget.currentRow;
        const prodInicial = row.CDARVPRODINI;
        const prodFinal   = row.CDARVPRODFIM;
        
        if(!validaProduto(prodInicial, prodFinal)){
            field.clearValue();
        }
    };

	this.validaReport = function(widget, currentRow) {

		if(widget.isValid()) {
			if(!Util.isEmptyObject(currentRow.ESCOLHAS)){
				General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow.REPORT_NAME, currentRow]);
			} else {
				MessageService.showMessageByCode("SITUACAO_AF_SELECT");
			}
		} else {
			MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
		}

	};

	this.abreRelatorio = function(widget, reportName, currentRow) {
		
		if(!window.projectCorp)
			currentRow.NMFILIAL = getLocalVar('CDFILIAL');
			
		currentRow.LISTAFILIAIS = !Util.isEmptyOrBlank(currentRow.NMFILIAL) ? currentRow.NMFILIAL.join('_') : 'T';
		currentRow.DTINICIAL    = currentRow.INTERVALO_DATA.start;
		currentRow.DTFINAL      = currentRow.INTERVALO_DATA.end;
		
		concatenaEscolhas(currentRow);
	
        General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp04100_baixa_afs', reportName, currentRow);

	}.bind(this);

	this.setInitValues = function(widget){
        
        const filterRow = {
    	    INTERVALO_DATA : {
                'formattedStart' : moment().format('DD/MM/YYYY'),
                'start'          : moment().format('DD/MM/YYYY'),
                'formattedEnd'   : moment().format('DD/MM/YYYY'),
                'end'            : moment().format('DD/MM/YYYY')
            },
            IDBAIXAAF : [ "0", "1", "2", "3" ],
            NMIDBAIXAAF : [ "Em Aberto", "Baixa Parcial", "Baixa Total", "Baixa Manual" ],
            IDAFEXPIRADA : "T"
        };
       
		Utilities.startFilter(widget, filterRow);
    };
    
    this.skipFilterZeedhi = function(args) {
    	args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.setDataSourceFilterBaixaAf = function (args) {
    	const row                   = args.e.preference.FILTER_ROW;
        const widget                = templateManager.container.getWidget('cmp04100');
        const filterPopupCurrentRow = widget.appliedFilter.FILTER_ROW;
        
    	widget.dataSourceFilter = [
    			{
    				"name": "P_DTINI",
    				"operator": "=",
    				"value": row.INTERVALO_DATA.start
    			},
    			{
    				"name": "P_DTFIN",
    				"operator": "=",
    				"value": row.INTERVALO_DATA.end
    			},
    			{
    				"name": "L_CDFILIAL",
    				"operator": "=",
    				"value": !row.CDFILDEST || Util.isEmptyObject(row.CDFILDEST) ? 'T' : row.L_CDFILIAL = '_' + row.CDFILDEST.join('_') + '_'
    			},
    			{
    				"name": "P_CDPRODINI",
    				"operator": "=",
    				"value": row.CDARVPRODINI
    			},
    			{
    				"name": "P_CDPRODFIN",
    				"operator": "=",
    				"value": row.CDARVPRODFIM + 'ZZZZZZZZZZZZZZZZZZZ'
    			},
    			{
    				"name": "P_IDBAIXAAF",
    				"operator": "=",
    				"value": row.IDBAIXAAF.join('_')
    			},
    			{
    				"name": "P_IDAFEXPIRADA",
    				"operator": "=",
    				"value": row.IDAFEXPIRADA
    			},
    			{
    				"name": "P_MODO",
    				"operator": "=",
    				"value": 'N'
    			}
    		];
    	
    	widget._filterInfo = [
            { "label": ScreenService.i18n("Unidade Destino"), "value" : concatArrayForParams(filterPopupCurrentRow.CDFILDEST, ScreenService.i18n("Todas"))},
            { "label": ScreenService.i18n("Situação da AF"), "value" : concatArrayForParams(setBaixaAF(filterPopupCurrentRow.IDBAIXAAF), ScreenService.i18n("Todas"))},
            { "label": ScreenService.i18n("Data de Entrega"), "value" : filterPopupCurrentRow.INTERVALO_DATA.formattedStart + ' a ' + filterPopupCurrentRow.INTERVALO_DATA.formattedEnd},
            { "label": ScreenService.i18n("Produto Inicial"), "value" : filterPopupCurrentRow.NMPRODUTOINI},
            { "label": ScreenService.i18n("Produto Final"), "value" : filterPopupCurrentRow.NMPRODUTOFIM},
        ];
    		
    	widget.reload();
    	widget.activate();
    };
    
    function setBaixaAF(IDBAIXAAF) {
        let baixa = [];
    	
    	IDBAIXAAF.forEach(function(idBaixa){
            switch (idBaixa) {
        	    case '0':
        	        baixa.push(ScreenService.i18n('Em Aberto'));
        	        break;
        	    case '1':
        	        baixa.push(ScreenService.i18n('Baixa Parcial'));
        	        break;
        	    case '2':
        	        baixa.push(ScreenService.i18n('Baixa Total'));
        	        break;
        	    case '3':
        	        baixa.push(ScreenService.i18n('Baixa Manual'));
        	        break;
        	    case '4':
        	        baixa.push(ScreenService.i18n('Encerrada'));
        	        break;
        	    case '5':
        	        baixa.push(ScreenService.i18n('Cancelada'));
        	        break;
        	    case 'S':
        	        baixa.push(ScreenService.i18n('Expirada'));
        	        break;
        	}
        });
        
        return baixa;
    }
    
    function validaProduto(prodInicial, prodFinal) {
        
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04100BaixaAFsController', Cmp04100BaixaAFsController);
});