var Cmp05200_AfsPorFornecedor_Controller = function (ScreenService, General, restEngine) {
    var listaUnidades = '';

    this.valoresDefault = function(widget) {
        if (!widget.currentRow.L_CDFILIAL) {
            widget.newRow();
        }

        widget.currentRow.DT_INTERVAL.end = moment().format('DD/MM/YYYY');
        widget.currentRow.DT_INTERVAL.start = moment().format('DD/MM/YYYY');
    };

    this.verificaCampoJoin = function (campo){
        if (!Util.isEmptyObject(campo)) {
            return '_' + campo.join('_') + '_';
        } else {
            return "T";
        }
    };
    
    this.montaParametrosRelatorio = function(currentRow) {
        var params = {
            'QR2TYPE': currentRow.QR2TYPE,
            'L_FILIAL': this.verificaCampoJoin(currentRow.CDFILIAL),
            'L_FORNECEDOR': this.verificaCampoJoin(currentRow.FORNECEDOR),
            'CDOPERADOR': this.verificaCampoJoin(currentRow.NMCOMPRADOR),
            'CDIMPOSTO': this.verificaCampoJoin(currentRow.SGIMPOSTO),
            'L_REGIAO': this.verificaCampoJoin(currentRow.NMREGIAO),
            'DTAFINI': currentRow.DT_INTERVAL.start,
            'DTAFFIN': currentRow.DT_INTERVAL.end,
            'RADIODATA': currentRow.RADIODATA,
            'FILIALLOGADA1': getLocalVar('CDFILIAL'),
            'FILIALLOGADA2': getLocalVar('CDFILIAL'),
            'RADIOIMPRIME': currentRow.RADIOIMPRIME,
            'IMPRIMEOBS': currentRow.IMPRIMEOBS,
            'IMPRIMEOBSPROD': currentRow.IMPRIMEOBSPROD,
            /* ProjectCorp true é Matriz, do contrário, Filial.
            Para o banco, o MODO 'N' equivale a Matriz, e Filial 'S'.*/
            'MODO': window.projectCorp === true ? 'N' : 'S',
            //Parametros especificos para um determinado cliente
            'NMMENSCMP': currentRow.NMMENSCMP ? currentRow.NMMENSCMP.join('_') : '',
            'CDMENSCMP': currentRow.CDMENSCMP ? currentRow.CDMENSCMP.join('_') : ''
        };
        
        return params;
    };

    this.geraRelatorio = function(widget, args) {
        var reportName;

        if (widget.isValid()) {
            reportName = widget.currentRow.REPORT_NAME;
            
            General.openReportPopup(widget, this.abreRelatorio, [widget, reportName]);
        }
    };

    this.abreRelatorio = function(widget, reportName) {
        var reportParams = this.montaParametrosRelatorio(widget.currentRow);
        
        General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp05200_afs_por_fornecedor', reportName, reportParams);
    }.bind(this);


    this.dataSourceRegiao = function() {
         return restEngine.post('cmp#/search_regiao_filial', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": listaUnidades
                }
            ]
        });
    };
    
    this.toggleReadOnlyMensagem = function (checkboxField) {
        var selectField = checkboxField.widget.getField('NMMENSAGEM'),
            currentRow = checkboxField.widget.currentRow;
        
		if (checkboxField.checked) {
			selectField.readOnly = true;
			selectField.validations = {};
			selectField.clearValue();
			currentRow.CDMENSCMP = '';
			currentRow.NMMENSCMP = '';
			selectField.reload();
		} else {
			selectField.readOnly = false;
			selectField.validations = {
				required: true
			};
			selectField.reload();
		}
	};

    /*
     * Metodo para controlar a quantidade de ítens por pagina do dataSource. Caso haja mais de 500 ítens, o item por página
     deve ser ajustado com um tamanho maior que o total de dados para evitar dupĺicação de dados caso a ação de selecionar tudo
     seja feita novamente
     */

    this.onSelectAllCliente = function(args) {
        args.owner.dataSource.itemsPerPage = args.owner.dataSource.data.length + 1;
        args.owner.reload();
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp05200_AfsPorFornecedor_Controller', Cmp05200_AfsPorFornecedor_Controller);
});