
function Cmp06100_ProdutosNaoComprados_Controller(General, ScreenService, localStorageEngine, templateManager, ZhFilterPreferences, MessageService) {

    var self = this;            //coloca self para não dar problema no this. quando é usado dentro de uma função para representar outra função do mesmo arquivo.
    var listaUnidades = '';
    
    //TODO voltar com as functions que concatena, mas modificadas para serem utilizadas de forma genérica
    this.setFilterInitValues = function(widget){
	    widget.currentRow.REPORT_NAME = "CMP06108.QR2";
	    widget.currentRow.RELSOLIEXTRA = "T";
        
	    widget.currentRow.INTERVALO_DATA = {};
	    widget.currentRow.INTERVALO_DATA.formattedStart = moment().format('L');
        widget.currentRow.INTERVALO_DATA.formattedEnd = moment().format('L');
	    widget.currentRow.INTERVALO_DATA.start = moment().format('L');
        widget.currentRow.INTERVALO_DATA.end = moment().format('L');
    };

    this.widgetOnEnter = function(widget) {
        widget.newRow();
    	this.setFilterInitValues(widget);
    };
    
    this.preparaRowParaRelatorio = function(widget) {
        var currentRow = widget.currentRow;
        var prodfin = '';
        
        if(currentRow.CDPRODFIN) {
            let cdprodfin = currentRow.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ";
            cdprodfin = cdprodfin.substring(0, 20);
            prodfin = cdprodfin;
        } else {
            let cdprodfin = "ZZZZZZZZZZZZZZZZZZZZ";
            prodfin = cdprodfin;
        }
        
        var newRow = {
            "REPORT_NAME": currentRow.REPORT_NAME,
            "CDREGIAO": (currentRow.L_REGIAO) ? currentRow.L_REGIAO.join('_') :  'T',
            "DATAINI": currentRow.INTERVALO_DATA.start,
            "DATAFIN": currentRow.INTERVALO_DATA.end,
            "PRODINI": currentRow.CDPRODINI ? currentRow.CDPRODINI : '',
            "PRODFIN": prodfin,
            "OPERADOR": (currentRow.L_COMPRADOR) ? currentRow.L_COMPRADOR.join('_') : 'T',
            "SISTEMA": window.projectCorp ? "SUP" : "CMP",
            "INDEXREL": currentRow.CHKBOXPART === 'S' ? 4 : 0,
            /*Exibe Particularidade '4'=Sim e '0'=Não*/
            "CDFILIAL": (currentRow.L_FILIAL) ? currentRow.L_FILIAL.join('_') : 'T',
            "CDFILIPROC": getLocalVar('CDFILIAL'),
            "CDGRUPFILI": (currentRow.L_GRUPFILI) ? currentRow.L_GRUPFILI : '',
            /*Exibe Observação da Compra 'S'=Sim ou 'N'=Não*/
            "RELCOMPRA": currentRow.CHKBOXOBSCMP,
            "RELESPECIFICO": null,
            /*Solicitação Extra 'S'=Sim ou 'N'=Ambas ou '2'=Não*/
            "RELSOLIEXTRA": currentRow.RELSOLIEXTRA,
            /*Quebrar Página por Comprador 'S'=Sim ou 'N'= Não
            No banco, o default é 'S'; 
            Até o dia 16/08/2018, no relatório QR2 NÃO há opção de exibir ou não
            o comprador, ou seja, sempre está exibindo, independente do valor passado;*/
            "CONSIDERACOMP": 'S'//currentRow.CHKBOXBRKPAG
        };
        
        return newRow;
   };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }
        return true;
    };
    
    this.setUnidadesNull = function(widget){
        widget.getField('L_FILIAL').clearValue();
    };
    
    this.selectUnidades = function(widget){
        var regiao = (widget.currentRow.L_REGIAO) ? widget.currentRow.L_REGIAO.join('_') :  'T';
        var filterName = regiao === 'T' ? "P_TCDREGIAO" : "P_CDREGIAO";
        
        if (widget.currentRow.L_GRUPFILI === null || widget.currentRow.L_GRUPFILI === "") {
            widget.getField('L_FILIAL').dataSource.name = "cmp_solicitacao_relatorios#/crud/cmp06100_filial_regiao";
            widget.getField('L_FILIAL').dataSourceFilter = [
                {
                    "name": filterName,
                    "operator": "=",
                    "value": regiao
                }
            ];
        }
        else {
            widget.getField('L_FILIAL').dataSource.name = "cmp_solicitacao_relatorios#/crud/cmp06100_filial_grup";
            widget.getField('L_FILIAL').dataSourceFilter = [
                {
                    "name": filterName,
                    "operator": "=",
                    "value": regiao
                },
                {
                    "name": "P_CDGRUPFILI",
                    "operator": "=",
                    "value": widget.currentRow.L_CDGRUPFILI
                }
            ];
        }
        
        widget.getField('L_FILIAL').reload();
    };
    
    this.changeRequired = function(field){
        if (field.widget.getField('NMPRODINI').value() || field.widget.getField('NMPRODFIN').value()){
            field.widget.getField('NMPRODINI').validations = { "required" : true };
            field.widget.getField('NMPRODFIN').validations = { "required" : true };
        } else {
            field.widget.getField('NMPRODINI').validations = {};
            field.widget.getField('NMPRODFIN').validations = {};
        }
    };
    
    
    this.criaRelatorio = function(widget) {
        if (widget.isValid()) {
            if (Util.isEmptyOrBlank(widget.currentRow.NMPRODINI) && Util.isEmptyOrBlank(widget.currentRow.NMPRODFIN)) {
                widget.currentRow.PRODUTO = 'T';
            } else if ((self.validaProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN))) {
                widget.currentRow.PRODUTO = 'X';
            } else {
                return;
            }
            
            var row = self.preparaRowParaRelatorio(widget);
            /* Abre o popup do general que pergunta o tipo de relatório que será gerado (pdf, etc.). 
            Os parâmetros passados podem ser vistos lá no arquivo General.js.*/
            General.openReportPopup(widget, self.abreRelatorio, [widget, row, widget.currentRow.REPORT_NAME]);
        }
    };
    
    
    this.abreRelatorio = function(widget, row, reportName) {
        row.QR2TYPE = widget.currentRow.QR2TYPE;
        
        const [name, strategy] = reportName.split('.');
        
        reportName = name;
        row.STRATEGY = strategy;
        
   	    General.openReport('cmp_solicitacao_relatorios#/cmp06100_relatorio', reportName, row);
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp06100_ProdutosNaoComprados_Controller', Cmp06100_ProdutosNaoComprados_Controller);
});