/******************************************************************************************/
/******************************************************************************************/
/*                                                                                        */
/* Trigger: DTULTATU_MODELO                                                               */
/* Tabela : MODELO                                                                        */
/*                                                                                        */
/* Criao:                                                                               */
/* 02/06/2009 - Andr Rodrigo                                                             */
/*                                                                                        */
/******************************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MODELO
BEFORE INSERT OR UPDATE OR DELETE
ON MODELO FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MODELO', '', 'CDFABRIC='||:OLD.CDFABRIC||
                                             ';CDMODELO='||:OLD.CDMODELO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MODELO MODIFY DTULTATU DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_MODELO','5.05.096'); END;
/
